%global pkg dinghai
%global kernel 6.6.25-2.an23
%define pkg_version 2.24.40.01
%define anolis_release 2

%global debug_package %{nil}

Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:     ZTE SmartNIC and DPU driver
License:     GPLv2
URL:         https://gitee.com/anolis/kmod-dinghai
Source0:     kmod-%{pkg}-%{pkg_version}.tar.gz
Epoch:       1

# 安装依赖, 和内核版本对应
Requires:            kernel >= %{kernel}
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

# 构建依赖, 和内核版本对应
BuildRequires:    kernel-devel   = %{kernel}
BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    system-rpm-config
BuildRequires:    perl-Data-Dumper

%define kernel_version %{kernel}.%{_arch}
%define kernel_source /usr/src/kernels/%{kernel}.%{_arch}

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
RPM Package for ZXDH Driver

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
pushd src/crypto/zsda
%{__make} %{?_smp_mflags} -C %{kernel_source} M=$PWD modules CONFIG_ACC_ZSDA_COMMON=m CONFIG_ACC_ZSDA_PF=m CONFIG_ACC_ZSDA_VF=m
popd
pushd src/net/build
    ./builder.sh -t clean --ksrc %{kernel_source}
    ./builder.sh -t kernel -m CONFIG_DINGHAI_ETH  -m CONFIG_ZXDH_AUXILIARY -m CONFIG_DINGHAI_PF -m CONFIG_ZXDH_SF -m CONFIG_DINGHAI_EN_AUX -m HAVE_DEV_PM_DOMAIN_ATTACH -m HAVE_BUS_FIND_DEVICE_GET_CONST -m CONFIG_DINGHAI_DH_CMD -m CONFIG_DINGHAI_NP -m CONFIG_ZXDH_MSGQ -m CONFIG_ZXDH_HARDWARE_BOND -m CONFIG_DINGHAI_PTP -m CONFIG_DINGHAI_TSN --ksrc %{kernel_source} -j 7
popd
pushd src/rdma
    ./build.sh --ksrc %{kernel_source} --use_rel_net_path
popd

%install
mkdir -p %{buildroot}/lib/modules/%{kernel_version}/extra/dinghai/crypto/
mkdir -p %{buildroot}/lib/modules/%{kernel_version}/extra/dinghai/net/
mkdir -p %{buildroot}/lib/modules/%{kernel_version}/extra/dinghai/rdma
for ko in $(find src/crypto/zsda/accdevice/ src/net/drivers/ src/rdma/ -name '*.ko'); do
    if [[ $ko == src/crypto/zsda/accdevice/* ]]; then
        target_dir=%{buildroot}/lib/modules/%{kernel_version}/extra/dinghai/crypto/
    elif [[ $ko == src/net/drivers/* ]]; then
        target_dir=%{buildroot}/lib/modules/%{kernel_version}/extra/dinghai/net/
    elif [[ $ko == src/rdma/* ]]; then
        target_dir=%{buildroot}/lib/modules/%{kernel_version}/extra/dinghai/rdma/
    fi
    %{__install} -D -t $target_dir $ko
done

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel_version}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

# Add zxdh_en_aux udev conf

%{__install} -d %{buildroot}%{_sysconfdir}/udev/rules.d/
echo 'ACTION!="add", GOTO="drivers_end"' > %{buildroot}%{_sysconfdir}/udev/rules.d/80-%{name}-dinghai10e_en_aux-drivers.rules
echo 'ENV{MODALIAS}=="dinghai10e_auxiliary:dinghai10e.en_aux", RUN{builtin}+="kmod load dinghai10e_en_aux"' >> %{buildroot}%{_sysconfdir}/udev/rules.d/80-%{name}-dinghai10e_en_aux-drivers.rules
echo 'LABEL="drivers_end"' >> %{buildroot}%{_sysconfdir}/udev/rules.d/80-%{name}-dinghai10e_en_aux-drivers.rules

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/crypto/zsda_common.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/crypto/zsda_pf.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/crypto/zsda_vf.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/dinghai10e_cmd.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/dinghai10e_auxiliary.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/dinghai10e_ptp.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/dinghai10e_tsn.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/dinghai10e_np.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/dinghai10e.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/net/dinghai10e_en_aux.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kernel_version}/extra/drivers/dinghai/rdma/zrdma.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
list_file="/var/run/rpm-%{pkg}-modules.list"
mkdir -p /var/run
for ko in $(find /lib/modules/%{kernel_version}/extra/dinghai/ -name '*.ko'); do
    echo "${ko}" >> $list_file
done

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
%defattr(644,root,root,755)
%license licenses
/lib/modules/%{kernel_version}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf
%{_sysconfdir}/udev/rules.d/80-%{name}-dinghai10e_en_aux-drivers.rules

%changelog
* Tue Feb 11 2025 hcf <han.chengfei@zte.com.cn>
- init kmod-dinghai-2.24.40.01 driver


